Polyglot logo

Polyglot IDE

An extensive interactive development environment for
Java language extensions

mailing lists

Supporting the adoption of new languages is hard because developers expect to have IDE support. The Polyglot IDE addresses this issue by providing an extensible IDE integrated with the Polyglot compiler framework. With the Polyglot IDE, you can extend Java with new language features such as domain-specific extensions, and obtain an IDE for your new language.

The Polyglot IDE is an Eclipse plugin that behaves similar to the Java IDE implemented by Eclipse's JDT. It can be installed easily through Eclipse. Polyglot extension developers can readily extend the Polyglot IDE to support their own language.

The IDE currently supports code editing and highlighting, compilation, and integrated error reporting. It has some navigation support and an extensible project creation wizard. Some features remain unimplemented but desirable, such as debugging support, full navigation, and refactoring support. We hope to generate interest in the user community for adding these features.

Installing the plugins using Software Update

Eclipse 3.8 (Juno) or newer is required. Older versions may work, but this is untested.

Install the Polyglot IDE as you would any other Eclipse plugin. The software site to give Eclipse is:

To install, do the following:
  1. In Eclipse, invoke the Install dialog:
    Help >> Install New Software...
  2. Under "Work with", enter the location
  3. Select the plugins you wish to install and click "Next".
  4. Click through the remaining dialogs and agree to the license (LGPL) to install the plugins.
  5. Restart Eclipse

Or, you can directly download the plugins you want.


The code for Polyglot IDE is freely available on GitHub. Pull requests are always welcome.


Credits and acknowledgments

The Polyglot IDE was developed by Karthik Bellur and Jed Liu.